(*
 * Exception handling.
 *
 * ----------------------------------------------------------------
 *
 * @begin[license]
 * Copyright (C) 2000 Jason Hickey, Caltech
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Author: Jason Hickey
 * @email{jyh@cs.caltech.edu}
 * @end[license]
 *)

open Fc_ir_exn_type

(*
 * Locations.
 *)
val debug_pos : bool ref
val debug_trace_pos : bool ref
val atom_pos : 'a -> 'a exn_loc
val int_pos : int -> 'a exn_loc -> 'a exn_loc
val string_pos : string -> 'a exn_loc -> 'a exn_loc

(*
 * Exception printer.
 *)
val print_exn : exn -> unit
val print_exn_chan : out_channel -> exn -> unit
val print_exn_loc : ('a -> unit) -> 'a exn_loc -> unit

(*
 * Catch an exception.
 *)
val catch : ('a -> 'b) -> 'a -> 'b

(*!
 * @docoff
 *
 * -*-
 * Local Variables:
 * Caml-master: "compile"
 * End:
 * -*-
 *)
